#!/usr/bin/python
# -*- encoding: utf-8 -*-

import os
import logging
from datetime import datetime

root_path = '/usr/local/sigpdv/logs/'
LOG_FILE = os.path.join(root_path, 'stoqdrivers.%s.log' % datetime.now().strftime('%d-%m-%Y'))
# traced = TraceContext(logfile=LOG_FILE)


class StoqdriversLog(object):
    def __init__(self, stdout=True):
        # Criar logger
        logger = logging.getLogger('stoqdrivers')
        logger.setLevel(logging.DEBUG)
        logger.propagate = 0

        # Adicionar arquivo logger
        file_handler = logging.FileHandler(LOG_FILE)

        # Criar formato e setar formato do cabeçalho
        formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
        file_handler.setFormatter(formatter)

        # Adicionar para gravar no logger
        logger.addHandler(file_handler)

        self.log = logger
        self.stdout = stdout

    def debug(self, text):
        self.log.setLevel(logging.DEBUG)
        self.log.debug(text)

    def info(self, text):
        self.log.setLevel(logging.INFO)
        self.log.info(text)

    def warning(self, text):
        self.log.setLevel(logging.WARNING)
        self.log.warn(text)

    def error(self, text):
        self.log.setLevel(logging.ERROR)
        self.log.error(text)

    def critical(self, text):
        self.log.setLevel(logging.CRITICAL)
        self.log.critical(text)


traced = StoqdriversLog()

if __name__ == '__main__':
    traced.info(LOG_FILE)
