# -*- Mode: Python; coding: iso-8859-1 -*-

from serial import EIGHTBITS, STOPBITS_ONE, PARITY_NONE
from zope.interface import implements

from stoqdrivers.exceptions import InvalidReply
from stoqdrivers.interfaces import IScale
from stoqdrivers.serialbase import SerialBase
from decimal import Decimal

class MF30(SerialBase):
    CMD_PREFIX = "\x05"
    CMD_SUFFIX = "\x02"
    EOL_DELIMIT = "\x03"

    implements(IScale)

    model_name = "Filizola MF-30"

    def __init__(self, device, consts=None):
        SerialBase.__init__(self, device)
        device.set_options(baudrate=9600, bytesize=EIGHTBITS,
                           stopbits=STOPBITS_ONE, parity=PARITY_NONE)

    def read_data(self):
        reply = self.writeline('')
        if 'I' in reply:
            raise InvalidReply(u'Erro ao obter o peso da balan�a')
        return Decimal(reply[2:])

