# -*- Mode: Python; coding: iso-8859-1 -*-

from serial import EIGHTBITS, STOPBITS_ONE, PARITY_NONE
from zope.interface import implements

from stoqdrivers.exceptions import InvalidReply
from stoqdrivers.interfaces import IScale
from stoqdrivers.serialbase import SerialBase
from decimal import Decimal
from sigpdv.tools.config import config

class Generic(SerialBase):
    CMD_PREFIX = chr(config['solicitaleitura'])
    CMD_SUFFIX = ''
    CMD_PREFIX_REAL = chr(config['charinicio'])
    EOL_DELIMIT = chr(config['charfim'])

    implements(IScale)

    model_name = "Generic Scale"

    def __init__(self, device, consts=None):
        SerialBase.__init__(self, device)
        device.set_options(baudrate=config['balancabaud'], bytesize=EIGHTBITS,
                           stopbits=STOPBITS_ONE, parity=PARITY_NONE, read_timeout=0.1)

    def read_data(self):
        reply = self.writeline('')
        if 'I' in reply:
            return Decimal('0')
        reply = reply.replace(self.CMD_PREFIX_REAL, '')

        if config['modelo_balanca'] == 'Filizola':
            return Decimal(reply) / Decimal('1e3')
        return Decimal(reply)

